#ifndef ABSTRACTSOFTWARE_SEEN
#define ABSTRACTSOFTWARE_SEEN

#include "globalParameters.h"
#include "particleBeam.h"
#include "nomDeLogiciel.h"
#include <iostream>
#include <string>

using namespace std;

class dataManager;

class abstractSoftware
{

 protected :

  unsigned numeroDeb_, numeroFin_;
  globalParameters* globParamPtr_;
  dataManager* dataManager_;
  string inputFileName_;
  nomDeLogiciel nameOfSoftware_;
  abstractSoftware();

  bool launchJob(string commandLine, string& resul);
  bool initComputationLimits(unsigned int numeroDeb,unsigned int numeroFin);
  bool ComputationLimitsOk() const;
 public :

  abstractSoftware(string inputFileName, globalParameters* globals, dataManager* dt);
  ~abstractSoftware() {;}

  inline nomDeLogiciel getNomDeLogiciel() const {
    return nameOfSoftware_;
  }

  virtual bool createInputFile(particleBeam* beamBefore,unsigned int numeroDeb, unsigned int numeroFin, string workingDir) = 0;


  virtual bool  execute(string workingDir) = 0;

 virtual bool buildBeamAfterElements(string workingDir) = 0;

    /** Color of the background of this sofware
     Should be a valid Css name as FFEEDD
     */
    virtual string getColor() = 0;

    /** Name of this software
     */
    inline string getName() const {
      return nameOfSoftware_.getString();
    }

};
#endif
